#include "Cliente/Basicas/CAllegroConfig.h"
#include "Cliente/Basicas/CTeclado.h"
#include "Cliente/CJogoCliente.h"
#include "CMarioDeElite.h"
#include <allegro.h>
#include <iostream>
using namespace std;

 CMarioDeElite::~CMarioDeElite(){
 delete  this->img;
delete  this->bope;
 delete  this->fundo;
 delete  this->superMarioDeElite;
   delete  this->deElite;
    delete  this->fundoPreto;
    delete  this->fundoPretoMaior;
    delete  this->caveiraMaior;
    delete  this->spriteGameOver;
    delete  this->buffer;
    delete  this->menu1;
    delete  this->menu2;
    delete  this->menu3;
    delete  this->menu4;
    delete  this->menu5;
    delete  this->ajuda;
    delete  this->nomesCreditos;
    delete  this->creditosPrincipal;
    delete  this->apresentacao;


}

void CMarioDeElite::carregarImagens(){
    PALETTE pal;
        this->img = create_bitmap(800, 600);
        this->bope = load_bitmap("apresentacaoDefinitiva/bope.bmp", pal);
        this->fundo = load_bitmap("apresentacaoDefinitiva/fundo.bmp", pal);
        this->superMarioDeElite = load_bitmap("apresentacaoDefinitiva/superMarioDeElite.bmp", pal);
        this->deElite = load_bitmap("apresentacaoDefinitiva/deElite.bmp", pal);
        this->fundoPreto = load_bitmap("apresentacaoDefinitiva/fundoPreto.bmp", pal);
        this->fundoPretoMaior = load_bitmap("apresentacaoDefinitiva/fundoPretoMaior.bmp", pal);
        this->caveiraMaior = load_bitmap("apresentacaoDefinitiva/caveiraMaior.bmp", pal);
        this->menu1 = load_bitmap("apresentacaoDefinitiva/apresentacao1.bmp", pal);
        this->menu2 = load_bitmap("apresentacaoDefinitiva/apresentacao2.bmp", pal);
        this->menu3 = load_bitmap("apresentacaoDefinitiva/apresentacao3.bmp", pal);
        this->menu4 = load_bitmap("apresentacaoDefinitiva/apresentacao4.bmp", pal);
        this->menu5 = load_bitmap("apresentacaoDefinitiva/apresentacao5.bmp", pal);
        this->ajuda = load_bitmap("apresentacaoDefinitiva/ajuda.bmp", pal);
        this->nomesCreditos = load_bitmap("apresentacaoDefinitiva/nomesCreditos.bmp", pal);
        this->creditosPrincipal = load_bitmap("apresentacaoDefinitiva/creditosPrincipal.bmp", pal);
        this->buffer = this->fundoPretoMaior;
        this->apresentacao = load_sample("Cliente/Recursos/tropa.wav");
}

void CMarioDeElite::desenharCaveiraInicial(BITMAP *screen, BITMAP *fundoPretoMaior, BITMAP *caveiraMaior){
    draw_sprite(screen, fundoPretoMaior, 0, 0);
    rest(1000);
    draw_sprite(screen, caveiraMaior, 0, 0);
    rest(200);
    draw_sprite(screen, fundoPretoMaior, 0, 0);
    rest(2000);
    draw_sprite(screen, caveiraMaior, 0, 0);
    rest(200);
    draw_sprite(screen, fundoPretoMaior, 0, 0);
    rest(2000);
    draw_sprite(screen, caveiraMaior, 0, 0);
    rest(2000);
}

void CMarioDeElite::desenharSimbolosDoBope(BITMAP *screen, BITMAP *fundo, BITMAP *bope, int xEsquerda, int xDireita, int yCima, int yBaixo){
        draw_sprite(screen, fundo, 0, 0);
                    rest(800);
        draw_sprite(screen, bope, xEsquerda, yCima);
                rest(800);
            draw_sprite(screen, fundo, 0, 0);
        draw_sprite(screen, bope, xDireita, yBaixo);
                rest(800);
            draw_sprite(screen, fundo, 0, 0);
        draw_sprite(screen, bope, xDireita, yCima);
                rest(800);
            draw_sprite(screen, fundo, 0, 0);
        draw_sprite(screen, bope, xEsquerda, yBaixo);
            rest(800);
        draw_sprite(screen, fundo, 0, 0);
        rest(800);
        draw_sprite(screen, bope, xEsquerda, yCima);
        draw_sprite(screen, bope, xDireita, yBaixo);
        draw_sprite(screen, bope, xDireita, yCima);
        draw_sprite(screen, bope, xEsquerda, yBaixo);
        rest(800);
}

void CMarioDeElite::bopeAndarDiagonal(BITMAP *fundo, BITMAP *bope){
        int xEsquerda = 0;
        int xDireita = 708;
        int yCima = 0;
        int yBaixo = 506;
        int i = 0;
        while(i < 20){
        xEsquerda+=15;
        xDireita-=15;
        yCima+=15;
        yBaixo-=15;
        draw_sprite(screen, fundo, 0, 0);
        draw_sprite(screen, bope, xEsquerda, yCima);
        draw_sprite(screen, bope, xDireita, yBaixo);
        draw_sprite(screen, bope, xDireita, yCima);
        draw_sprite(screen, bope, xEsquerda, yBaixo);
           i++;
        rest(50);
        }
        rest(500);

}

void CMarioDeElite::aparecerCaveiraComEfeitoTunel(BITMAP *bope){
    int xEsquerda = 300;
    int yCima = 300;
    int yBaixo = 206;
    int i = 0;
    draw_sprite(screen, bope, xEsquerda + 52, (yCima+yBaixo)/2 + 2);
    rest(1000);

        int xSize = 92;
        int ySize = 94;
        int xPos = xEsquerda + 46;
        int yPos = (yBaixo + yCima)/2;
        for (int step = 1; step < 30; step++) {
             xSize += 92;
             ySize += 94;
             xPos = xPos - 46;
         yPos = yPos - 47;
             stretch_sprite(screen, bope, xPos, yPos, xSize, ySize);

         rest(100);
          }

        for (int step = 1; step < 35; step++) {

             xSize -= (92-step);
             ySize -= (94-step);
             xPos = xPos + 46 - (step/2);
             yPos = yPos + 47 -(step/2);
             stretch_sprite(screen, bope, xPos, yPos, xSize, ySize);
             rest(100);
          }
          rest(200);

}

void CMarioDeElite::marioDeEliteComEfeitoTunel(BITMAP *superMarioDeElite, BITMAP *buffer){
    for (int step = 20; step > 1; step--) {
             int width = SCREEN_W / step;
             int height = SCREEN_H / step;
             stretch_sprite(buffer, superMarioDeElite, SCREEN_W / step - width / 2,
         SCREEN_H / step - height / 2, width, height);
         draw_sprite(screen, buffer, 0, 0);
         rest(100);
          }
        draw_sprite(buffer, superMarioDeElite, 0, 0);
        draw_sprite(screen, buffer, 0, 0);
}

void CMarioDeElite::aparecerFiguraDeElite(BITMAP *DeElite, BITMAP *buffer){
        int i = 0;
        int x = 640;
        int y = 480;
        while(i < 18){
          x -= 11;
          y -= 9;
          draw_sprite(buffer, deElite, x, y);
           draw_sprite(screen, buffer, 0, 0);
           i++;
           rest(30);
        }
}

void CMarioDeElite::bopeNaApresentacaoFinal(BITMAP *bope, BITMAP *buffer){
        int i = 0;
        int x = 10;
        int y = -77;
        while(i < 45){
           draw_sprite(buffer, fundoPreto, x, y);
           if(i < 20){
          y += 19;
          }else{
             x += 10;
          }
          draw_sprite(buffer, bope, x, y);
          draw_sprite(screen, buffer, 0, 0);
           i++;
           rest(70);
        }

}


