#include "CFachadaServidor.h"

//contrutor
CFachadaServidor::CFachadaServidor(int numPlayers){
    this->jogoServidor = new CJogoServidor(numPlayers);
}

//destrutor
CFachadaServidor::~CFachadaServidor(){
    delete this->jogoServidor;
}

//passarEntrada
//envia a entrada do jogo para a camada abaixo (CJogoServidor)
void CFachadaServidor::passarEntrada(int entrada){
    this->jogoServidor->receberEntrada(entrada);
}

//processarEntradas
void CFachadaServidor::processarEntrada(){
    this->jogoServidor->processarEntrada();
}

SCena CFachadaServidor::getCenaAtual(){
    return this->jogoServidor->getCenaAtual();
}

//getEstadoJogo
EEstadoJogo CFachadaServidor::getEstadoJogo(){
    return this->jogoServidor->getEstadoJogo();
}

//getFaseAtual
EFase CFachadaServidor::getFaseAtual(){
    return this->jogoServidor->getFaseAtual();
}

int CFachadaServidor::getVencedor(){
    return this->jogoServidor->getVencedor();
}
