#include "CPintor.h"
#include <iostream>
using namespace std;
CPintor::CPintor(){
    this->telaTemp = create_bitmap(MAX_X,MAX_Y);
}

CPintor::~CPintor(){
    delete this->telaTemp;
}

BITMAP *CPintor::getTelaTemp(){
    return this->telaTemp;
}

void CPintor::desenharCenario(BITMAP *cenario){
    draw_sprite(this->telaTemp,cenario,0,0);
}

void CPintor::desenharObjetos(BITMAP * objeto,int x, int y,bool invertido){
   if(invertido){
   draw_sprite_h_flip(this->telaTemp,objeto,x,y);
   }else{
   draw_sprite(this->telaTemp,objeto,x,y);
   }
}

void CPintor::showFrame(){
    draw_sprite(screen,this->telaTemp,0,0);
}


//escreverTexto
void CPintor::escreverTexto(const char *texto,int x,int y){
    textout_ex(this->telaTemp,font,texto,x,y,makecol(255,255,255),-1);
}

//escreverTexto
void CPintor::escreverInteiro(int texto,int x,int y){
    textprintf_ex(this->telaTemp,font,x,y,makecol(255,255,255),-1,"%d",texto);
}


//limparTela
void CPintor::limparTela(){
	clear(this->telaTemp);
}
