#include "CFachadaCliente.h"

//construtor
CFachadaCliente::CFachadaCliente(int numPlayers){
    this->fachadaServidor = new CFachadaServidor(numPlayers);
}

//destrutor
CFachadaCliente::~CFachadaCliente(){
    delete this->fachadaServidor;
}

//passarEntrada
void CFachadaCliente::passarEntrada(int entrada){
    this->fachadaServidor->passarEntrada(entrada);
}

//processarEntradas
void CFachadaCliente::processarEntrada(){
    this->fachadaServidor->processarEntrada();
}

SCena CFachadaCliente::getCenaAtual(){
    return this->fachadaServidor->getCenaAtual();
}

//getEstadoJogo
EEstadoJogo CFachadaCliente::getEstadoJogo(){
    return this->fachadaServidor->getEstadoJogo();
}

//getFaseAtual
EFase CFachadaCliente::getFaseAtual(){
    return this->fachadaServidor->getFaseAtual();
}

int CFachadaCliente::getVencedor(){
    return this->fachadaServidor->getVencedor();
}
