#ifndef CBALA_H_
#define CBALA_H_

#include "CObjeto.h"
#include "../Enumeracoes/ESentido.h"

/*
Subclasse de objeto que determina uma bala (depois de disparada)
*/
class CBala : public CObjeto{
    private:
        int dano, idDono;
        ESentido sentido;
        CBala *proxima;
        bool colidiu;

    public:
        CBala(int,int,int,int,int,int,int,int,ESentido);

        int getDano();
        int getIdDono();
        bool getColidiu();
        ESentido  getSentido();
        CBala *getProxima();
        void setDano(int);
        void setIdDono(int);
        void setProxima(CBala *);
        void setColidiu(bool colidiu);
};

#endif
