#ifndef CCENARIO_H_
#define CCENARIO_H_

#include "CPlayer.h"
#include "CBala.h"
#include "CInimigo.h"
#include "CObjeto.h"
#include "stdlib.h"




#define LIFE        100


class CCenario{
    public:
    CCenario(int fase, int numPlay);
    ~CCenario(void
    );

    private:
    int numPlayers, numMonstros, numBalas, numPlataformas, numObejtos;

    CPlayer * arrayPlayers[2];
    CInimigo * arrayMonstros[10];
    CBala * arrayBalas[100];
    CObjeto * arrayPlataformas[11];

    public:
    int getNumPlayers(void);
    int getNumMonstros(void);
    int getNumBalas(void);
    int getNumPlataformas(void);
    int getNumObejtos(void);
    CPlayer** getarrayPlayers(void);
    CInimigo** getarrayMonstros(void);
    CBala** getarrayBalas(void);
    CObjeto** getarrayPlataformas(void);
    void setNumPlayers(int numPlayers);
    void setNumMonstros(int numMonstros);
    void setNumBalas(int numBalas);
    void setNumPlataformas(int numPlataformas);
    void setNumObejtos(int numObejtos);

    private:
    void inserirPlataforma(CObjeto *plataforma);
    //void inserirPlayer(CPlayer *player);
    void inserirMonstro(CInimigo *monstro);

    public:
    void inserirBala(CBala *bala);
    void removerBala(int pos);
    void removerPlayer(int pos);
    void removerMonstro(int pos);


};

#endif // CCENARIO_H_
