
#include "CHeap.h"
#include "Math.h";
#include <iostream>
using namespace std;


CHeap::CHeap(CObjeto ** a, CPersonagem * personagem, EEixo  eixo, int tamanho){
	this->a = a;
	this->personagem = personagem;
	this->eixo = eixo;
	this->tamanho = tamanho;

}

void CHeap::heapify(int i){
	CObjeto * maior = NULL;
	CObjeto * maior2 = NULL;
	int posicao = 0;
	while(2*i  + 2 <= (this->tamanho)){
		if(2*i  + 2 < (this->tamanho)){
			maior = this->prioridade(this->a[2*i + 1],this->a[2*i + 2]);
			if(maior == (this->a[2*i + 1]))
				posicao = 2*i + 1;
			else
				posicao = 2*i + 2;
		}else{
			maior = this->a[2*i +1];
			posicao = 2*i + 1;
		}
		maior2 = this->prioridade(this->a[i],maior);
		if(maior2 == maior){
			CObjeto* temp = this->a[i];
			this->a[i] = maior;
			this->a[posicao] = temp;
			i = posicao;
		}else
			i = this->tamanho;
	}

}

CObjeto * CHeap::prioridade(CObjeto * objeto1, CObjeto * objeto2){
	CObjeto * retorno = NULL;
	int dist1 = abs(this->personagem->getPosicao(this->eixo) - objeto1->getPosicao(this->eixo));
	int dist2 = abs(this->personagem->getPosicao(this->eixo)- objeto2->getPosicao(this->eixo));

	if(dist1 <= dist2)
		retorno = objeto1;
	else if(dist1 > dist2)
		retorno = objeto2;
	return retorno;
}

void CHeap::ConstruirHeap(){
     for(int i = (this->tamanho/2 -1) ; i >= 0; i = i -1)
     this->heapify(i);
}

CObjeto *  CHeap::remover(){
    CObjeto * retorno = this->a[0];
    this->a[0]  = this->a[this->tamanho - 1];
    this->a[this->tamanho - 1] = NULL;
    this->tamanho = this->tamanho - 1;
    this->heapify(0);
    return retorno;
}
