#include "CObjeto.h"

CObjeto::CObjeto(int xPos,int yPos,int largura,int altura,int xSpeed,int ySpeed){
    this->xPos = xPos;
    this->yPos = yPos;
    this->largura = largura;
    this->altura = altura;
    this->xSpeed = xSpeed;
    this->ySpeed = ySpeed;
}

int CObjeto::getPosicao(EEixo eixo){
    int retorno;

    if(eixo == EIXO_X){
        retorno = this->xPos;
    }
    else{
        retorno = this->yPos;
    }

    return retorno;
}

int CObjeto::getDimensao(EEixo eixo){
    int retorno;

    if(eixo == EIXO_X){
        retorno = this->largura;
    }
    else{
        retorno = this->altura;
    }

    return retorno;
}

int CObjeto::getVelocidade(EEixo eixo){
    int retorno;

    if(eixo == EIXO_X){
        retorno = this->xSpeed;
    }
    else{
        retorno = this->ySpeed;
    }

    return retorno;
}

void CObjeto::setPosicao(int valor,EEixo eixo){
    if(eixo == EIXO_X){
        this->xPos = valor;
    }
    else{
        this->yPos = valor;
    }
}

void CObjeto::setDimensao(int valor,EEixo eixo){
    if(eixo == EIXO_X){
        this->largura = valor;
    }
    else{
        this->altura = valor;
    }
}

void CObjeto::setVelocidade(int valor,EEixo eixo){
    if(eixo == EIXO_X){
        this->xSpeed = valor;
    }
    else{
        this->ySpeed = valor;
    }
}
