#include "CPersonagem.h"

CPersonagem::CPersonagem(int xPos,int yPos,int largura,int altura,int xSpeed,int ySpeed,ESentido sentido,int pontosDeVida,int delayTiro, int tipo, EEstado estado,EMovimento mov, int score) :
CObjeto::CObjeto(xPos,yPos,largura,altura,xSpeed,ySpeed){
    this->sentido = sentido;
    this->pontosDeVida = pontosDeVida;
    this->delayTiro = delayTiro;
    this->tipo = tipo;
	this->estado = estado;
	this->mov = mov;
	this->contadorDeTiros = 0;
	this->score = score;
}

ESentido CPersonagem::getSentido(){
    return this->sentido;
}

EMovimento  CPersonagem::getMov(){
 return this->mov;
}

int CPersonagem::getPontosDeVida(){
    return this->pontosDeVida;
}

int CPersonagem::getDelayTiro(){
    return this->delayTiro;
}

void CPersonagem::setSentido(ESentido sentido){
    this->sentido = sentido;
}

void CPersonagem::setMov(EMovimento mov){
    this->mov = mov;
}

void CPersonagem::diminuirPontosDeVida(int valor){
    this->pontosDeVida = this->pontosDeVida - valor;
}

void CPersonagem::setDelayTiro(int delayTiro){
    this->delayTiro = delayTiro;
}


EEstado CPersonagem::getEstado(void){
    return this->estado;
}

int CPersonagem::getTipo(void){
    return this->tipo;
}

void CPersonagem::setEstado(EEstado estado){
    this->estado = estado;
}

int CPersonagem::getContadorDeTiro(){
 return this->contadorDeTiros;
}

void CPersonagem::incrementarContadorDeTiro(){
 if(this->contadorDeTiros != this->delayTiro){
    this->contadorDeTiros++;
 }

}

void CPersonagem::setContadorDeTiro(int contador){
   this->contadorDeTiros = contador;
}

int CPersonagem::getScore(){
    return this->score;
}

void CPersonagem::incrementarScore(int valor){
    this->score += valor;
}

